<template>

  <q-page>
    <div class="q-pa-md row items-start q-gutter-md">
      <div style="margin-bottom: 35px" class="row items-start q-gutter-md">
        <div v-for="note in notes" :key="note.id">
          <CardShowNote @click="showModalUpdate(note)" @update="getNotesArchived()" :data="note"></CardShowNote>
        </div>

      </div>
    </div>
    <div class="q-pa-lg flex flex-center">
      <q-pagination
        v-model="pagination.current_page"
        :max="pagination.last_page"
        input
        input-class="text-orange-10"
      />
    </div>
  </q-page>
  <q-dialog @hide="showModal = false" v-model="showModal">
    <FormComponent @close="closeModalUpdate()" action="update" :note-information="formUpdate"></FormComponent>
  </q-dialog>
</template>

<script>
import axios from "axios";
import {apiUrl} from "src/config";
import CardShowNote from "components/notes/CardShowNote.vue";
import FormComponent from "components/notes/FormComponent.vue";

export default {
  name: "ArchivedNotes",
  components: {FormComponent, CardShowNote},
  data() {
    return {
      notes: [],
      apiUrl: apiUrl,
      showModal: false,
      formUpdate: {},
      pagination: {
        current_page: 1,
        last_page: 1,
        prev_page_url: 1,
        next_page_url: 1
      },
    }
  },
  methods: {
    getNotesArchived(page = this.pagination.current_page) {
      axios.get(`${this.apiUrl}notes/archived?page= ${page}`)
        .then(res => {
          this.notes = res.data.notes;
          this.pagination = res.data.pagination;
        })
        .catch(err => {
          console.error(err)
        })
    },
    closeModalUpdate() {
      this.showModal = false;
      this.notes = [];
      this.getNotesArchived();
    },
    showModalUpdate(note) {
      this.formUpdate = note;
      this.showModal = true;
    },
  },
  watch: {
    'pagination.current_page': function (newPage, oldPage) {
      this.getNotesArchived(newPage);
    }
  },
  mounted() {
    this.getNotesArchived();
  }
}
</script>

<style>
.w-500 {
  width: 300px;
}

</style>
